local THIS_RAID = {
    idx = 1, 
    str = 'ThroneOfThunder',
    display = 'Throne of Thunder',
    bosses = {},
}

local FROSTKING = 'Frost King Malakk'
local KAZRAJIN = 'Kazra\'jin'
local SUL = 'Sul the Sandcrawler'
local PRIESTESS = 'High Priestess Mar\'li'

local BOSS_ID = {
    [FROSTKING] = 'Council of Elders',
    [KAZRAJIN] = 'Council of Elders',
    [SUL] = 'Council of Elders',
    [PRIESTESS] = 'Council of Elders',
    ['Flaming Head'] = 'Megaera',
    ['Frozen Head'] = 'Megaera',
    ['Venomous Head'] = 'Megaera',
    ['Arcane Head'] = 'Megaera',
    ['Anima Orb'] = 'Dark Animus',
    ['Anima Golem'] = 'Dark Animus',
    ["Ro'shak"] = 'Iron Qon',
    ["Quet'zal"] = 'Iron Qon',
    ["Dam'ren"] = 'Iron Qon',
    ['Suen'] = 'Twin Consorts',
    ['Lu\'lin'] = 'Twin Consorts',
}


local DATA = {
    ------------------------------------------------------------------
    
    ['Jin\'rokh the Breaker'] = {
        idx = 1,
        events = {
            'Lightning Storm 1',
            'Lightning Storm 2',
            'Lightning Storm 3',
            'Lightning Storm 4',
        },
        
        msgs = {},
        
        init = function ()
            Raidbot_counter['Lightning Storm'] = 0
        end,
        
        onevent = function (spellName, event)
            --
        end,
        
        onemote = function (sender, msg)
            if msg:match('begins to channel') and msg:match('Lightning Storm') then
                Raidbot_counter['Lightning Storm'] = Raidbot_counter['Lightning Storm'] + 1
                Raidbot_SendEventMessages ('Lightning Storm '..tostring(Raidbot_counter['Lightning Storm']))
            end
        end,        
    },
    ------------------------------------------------------------------
    
    ['Horridon'] = {
        idx = 2,
        events = {
        },
        
        msgs = {},
        
        init = function ()
            
        end,
        
        onevent = function (spellName, event)
            --
        end,
        
        onemote = function (sender, msg)
            
        end,        
    },
    ------------------------------------------------------------------
    
    ['Council of Elders'] = {
        idx = 3,
        events = {
            FROSTKING..' possessed',
            KAZRAJIN..' possessed',
            SUL..' possessed',
            PRIESTESS..' possessed',
            'Blessed Loa Spirit',
            'Shadowed Loa Spirit',
        },
        
        msgs = {},
        
        init = function ()
            
        end,
        
        onevent = function (spellName, event)
            --
        end,
        
        onemote = function (sender, msg)
            if msg:match('Possessed') then
                Raidbot_SendEventMessages (sender..' possessed')
            elseif msg:match('summons') then
                if msg:match('Blessed Loa Spirit') then
                    Raidbot_SendEventMessages ('Blessed Loa Spirit')
                elseif msg:match('Shadowed Loa Spirit') then
                    Raidbot_SendEventMessages ('Shadowed Loa Spirit')
                end
            end
        end,        
    },
    ------------------------------------------------------------------
    
    ['Tortos'] = {
        idx = 4,
        events = {
        },
        
        msgs = {},
        
        init = function ()
            
        end,
        
        onevent = function (spellName, event)
            --
        end,
        
        onemote = function (sender, msg)
            
        end,        
    },
    ------------------------------------------------------------------
    
    ['Megaera'] = {
        idx = 5,
        events = {
            'Rampage 1',
            'Rampage 2',
            'Rampage 3',
            'Rampage 4',
            'Rampage 5',
            'Rampage 6',
        },
        
        msgs = {},
        
        init = function ()
            Raidbot_counter['Rampage'] = 0
        end,
        
        onevent = function (spellName, event)
            --
        end,
        
        onemote = function (sender, msg)
            if msg:match('Megaera begins to') and msg:match('Rampage') then
                Raidbot_counter['Rampage'] = Raidbot_counter['Rampage'] + 1
                Raidbot_SendEventMessages ('Rampage '..tostring(Raidbot_counter['Rampage']))
            end
        end,        
    },
    ------------------------------------------------------------------
    
    ['Ji-Kun'] = {
        idx = 6,
        events = {
            'Quills',
        },
        
        msgs = {},
        
        init = function ()
            
        end,
        
        onevent = function (spellName, event)
            if spellName=='Quills' and event=='SPELL_CAST_START' then
                Raidbot_SendEventMessages ('Quills')
            end
        end,
        
        onemote = function (sender, msg)
            
        end,        
    },
    ------------------------------------------------------------------
    
    ['Durumu the Forgotten'] = {
        idx = 7,
        events = {
            'Light Spectrum',
        },
        
        msgs = {},
        
        init = function ()
            
        end,
        
        onevent = function (spellName, event)
            
        end,
        
        onemote = function (sender, msg)
            if msg:match('Use the cones of light') then
                Raidbot_SendEventMessages ('Light Spectrum')
            end
        end,        
    },
    ------------------------------------------------------------------
    
    ['Primordius'] = {
        idx = 8,
        events = {
        },
        
        msgs = {},
        
        init = function ()
        end,
        
        onevent = function (spellName, event)
        end,
        
        onemote = function (sender, msg)
        end,        
    },
    ------------------------------------------------------------------
    
    ['Dark Animus'] = {
        idx = 9,
        events = {
            'Anima Ring',
        },
        
        msgs = {},
        
        init = function ()
        end,
        
        onevent = function (spellName, event)
            if spellName=='Anima Ring' and event:match('SPELL_CAST') then
                Raidbot_SendEventMessages ('Anima Ring')
            end
        end,
        
        onemote = function (sender, msg)
        end,        
    },
    ------------------------------------------------------------------
    
    ['Iron Qon'] = {
        idx = 10,
        events = {            
        },
        
        msgs = {},
        
        init = function ()
        end,
        
        onevent = function (spellName, event)
            
        end,
        
        onemote = function (sender, msg)
        end,        
    },
    ------------------------------------------------------------------
    
    ['Twin Consorts'] = {
        idx = 11,
        events = {            
        },
        
        msgs = {},
        
        init = function ()
        end,
        
        onevent = function (spellName, event)
            
        end,
        
        onemote = function (sender, msg)
        end,        
    },
    ------------------------------------------------------------------
    
    ['Lei Shen'] = {
        idx = 12,
        events = {
            'Transition 1 start',
            'Transition 1 end',
            'Transition 2 start',
            'Transition 2 end',
        },
        
        msgs = {},
        
        init = function ()
            Raidbot_counter['Transition'] = 0
        end,
        
        onevent = function (spellName, event)
            if spellName=='Supercharge Conduits' and event=='SPELL_CAST_START' then
                Raidbot_counter['Transition'] = Raidbot_counter['Transition'] + 1
                Raidbot_SendEventMessages ('Transition '..tostring(Raidbot_counter['Transition'])..' start')
            end
        end,
        
        onemote = function (sender, msg)
            if msg:match('about to end') and msg:match('Supercharge Conduits') then
                Raidbot_SendEventMessages ('Transition '..tostring(Raidbot_counter['Transition'])..' end')
            end
        end,
    },
    ------------------------------------------------------------------
    
    --[[['Docile Porcupine'] = {                -- to anyone reading through my code: i assure you that this one was purely for testing purposes!
        idx = 1,
        events = {
            'Quill Barb 1',
            'Quill Barb 2',
            'Quill Barb 3',
        },
        
        msgs = {},
        
        init = function ()
            Raidbot_counter['Quill Barb'] = 0
        end,
        
        onevent = function (spellName, event)
            if spellName=='Quill Barb' and event=='SPELL_CAST_START' then
                Raidbot_counter['Quill Barb'] = Raidbot_counter['Quill Barb'] + 1
                print ('Quill Barb ',Raidbot_counter['Quill Barb'])
                Raidbot_SendEventMessages ('Quill Barb '..tostring(Raidbot_counter['Quill Barb']))
            end
        end,
        
        onemote = function (sender, msg)
            --
        end,
    },]]
    ------------------------------------------------------------------

}


function Raidbot_LoadData_ThroneOfThunder (bigTable, lstRaids, lstBossId)
    for k,v in pairs(DATA) do
        bigTable[k] = v
        for i,event in pairs(v.events) do
            bigTable[k].msgs[event] = {}
        end
        
        THIS_RAID.bosses[v.idx] = k
    end
    lstRaids[THIS_RAID.idx] = THIS_RAID
    
    for k,v in pairs(BOSS_ID) do
        lstBossId[k] = v
    end
    
    print ('Raidbot: loaded '..THIS_RAID.display)
end
